from __future__ import division
from geodata.core.helpers.shortcuts import FindMaxMinIndex, UpdateListColumn
__author__ = 'pav'
#-----------------------------------------------------
#
#   Geodata generic classifiers class
#
#
#-----------------------------------------------------

ttp = 21

t_list = [
    ["tele_photo_1", "xy1", 'timastamp', 0],
    ["tele_photo_2", "xy1", 'timastamp', 2],
    ["tele_photo_3", "xy1", 'timastamp', 9],
    ["tele_photo_4", "xy1", 'timastamp', 11],
]

tmp = [
    ["tele_photo_1", "xy1", 'timastamp', 0],
    ["tele_photo_2", "xy1", 'timastamp', 2],
    ["tele_photo_3", "xy1", 'timastamp', 9],
    ["tele_photo_4", "xy1", 'timastamp', 11],
]

w_list = [
    ["wide_photo_1", "xy1", 'timastamp', 0],
    ["wide_photo_2", "xy1", 'timastamp', 2],
    ["wide_photo_3", "xy1", 'timastamp', 3],
    ["wide_photo_4", "xy1", 'timastamp', 10],
    ["wide_photo_5", "xy1", 'timastamp', 12],
    ["wide_photo_6", "xy1", 'timastamp', 18],
]

class Bin():
    """
        Abstruct Class for Bucket classification
    """
    items = 0
    def __init__(self, *args, **kwargs):
        self.max_value, self.min_value = args
        self.elements = []
        self.sum = 0

    def SetItem(self, item):
        self.elements.append(item)
        self.sum += 1
        Bin.items += 1

    def check(self, obj):
        if obj in range(self.min_value, self.max_value+1):
            self.SetItem(obj)

    def clear(self):
        self.elements = []
        self.sum = 0
        Bin.items = 0

    def __str__(self):
        return u"Bin (%d - %d) elements: %s" % (self.min_value, self.max_value,str(self.elements))


def StartVideoProcess(wide):
    wide_l = [i[3] for i in wide]
    wide_l.append(ttp)
    st = int(wide[0][3])
    buckets = []
    for i in wide_l:
        if int(i) - st > 2:
            buckets.append(Bin(i-1, st+1))
        st = int(i)
    return buckets

def TeleComp(buckets, tele):
    for i in tele: i[3] = int(i[3])+1
    for i in tele:
        for j in buckets: j.check(int(i[3]))
    return buckets[0].items / float(len(tele))


def RecursiveVideoTagScore(tele, wide, ttp):
    times = ttp - 11
    offsets = [i for i in range(1, times+1)]
    buckets = StartVideoProcess(wide)
    results = []
    for i in offsets:
        results.append([i, TeleComp(buckets, tele)])
        for j in buckets: j.clear()
    return [i for i in results if i[1]==max([j[1] for j in results])][0]


def VideoTeleTag(wide, tele, ttp, index, tmp):
    return UpdateListColumn(tele, index, RecursiveVideoTagScore(tmp, wide, ttp)[0])

if __name__ == '__main__':
    a = VideoTeleTag(w_list, t_list, ttp, 3, tmp)
    for i in a:
        print i

