__author__ = "pav"
import psycopg2


class DBHandler():
    """
        ---------- DBHandler class ------------
        Implements a connection and queries ability
        against Postgesql Server

        Example usage:
            obj = DBHandler('<dbname>', '<dbuser>', '<dbpassword>')
            obj.connect()
            obj.query = "SELECT .... INSERT ..."
            obj.execute()
            obj.commit()
    """

    def __init__(self, db, user, password):
        self.DB = db
        self.user = user
        self.password = password
        self.con = None
        self.pg = None
        self.query = None
        self.sql_cache = []

    def connect(self):
        """
            Connect to database before queries - insert's - updates etc
        """
        self.pg = psycopg2.connect(database=self.DB, user=self.user, password=self.password)
        self.con = self.pg.cursor()

    def commit(self):
        """
            Always commit after changes in Database
        """
        self.pg.commit()
        self.con.close()

    def query(self, Q):
        """
            test insert
        """
        self.query = Q

    def QueryCache(self):
        self.sql_cache.append(self.query + "\n")

    def execute(self):
        self.con.execute(self.query)


def UnitTest():
    inst = DBHandler("geomedia", "geotag", "iverson")
    inst.connect()
    inst.query =""" SELECT version();"""
    inst.execute()
    var = inst.con.fetchone()
    print var
    inst.commit()


#--------- Test module -----------------------

if __name__ == '__main__':
    UnitTest()