__author__ = 'pav'
from geodata.settings import DB, os
from geodata.dist.data_backend.processor import DataEntry
from geodata.dist.query_backend.query import QueryBuilder


class Framework():
    """
        The basic class that abstructs the functionality of initial data handling
    """

    def __init__(self, region, region_path):
        self.region = region
        self.region_path = region_path
        self.tele_path = os.path.join(region_path, "Tele")
        self.wide_path = os.path.join(region_path, "Wide")
        self.video_path = os.path.join(region_path, "video")
        self.DBQuery = QueryBuilder()
        self.DBQuery.setDB(DB["name"], DB["usr"], DB["pass"])
        self.DataInput = DataEntry(
            self.wide_path,
            self.tele_path,
            self.video_path,
            self.region
        )

    def RawData(self):
        self.DataInput.InitialBuilder()

    def AutoCorrection(self, video_offset):
        self.DataInput.Sanitize(video_offset=video_offset)

    def ExecQueries(self):
        self.DBQuery.ExecAll(
            self.DataInput.region  ,self.DataInput.wdata + self.DataInput.tdata, self.DataInput.video_list
        )

    def ExportQueries(self):
        data =  self.DataInput.wdata + self.DataInput.tdata
        for i in data:
            print i
        self.DBQuery.ExportAll(
            os.path.join(self.region_path, "insert.sql"), self.DataInput.region,data, self.DataInput.video_list
        )


def Test():
    a = Framework(
        "Trikeri",
        r"C:\Users\pav\Desktop\dbdata\dataset-GEO\trikeri",
    )
    a.RawData()
    a.AutoCorrection(7)
    a.ExecQueries()

if __name__ == '__main__':
    Test()